// ////////////////////////////////////////////////////////////////////
// Copyright (C) 2001 Robert Wiejak
// e-mail: roberw@telus.net
// ////////////////////////////////////////////////////////////////////

HHOOK hMHook = NULL;			// handle to the mouse hook
BOOL bNcLButtonDown = FALSE;	// status of non-client left button down

// ////////////////////////////////////////////////////////////////////
// Mouse hook process

LRESULT CALLBACK MouseHookProc(int nCode, WPARAM wParam, LPARAM lParam) 
{ 
    if(nCode == HC_ACTION) 
    { 
        // get a pointer to the mouse hook struct. 
        PMOUSEHOOKSTRUCT mhs = (PMOUSEHOOKSTRUCT) lParam; 
        
        // intercept messages for left button down and up
        switch(wParam) 
        { 
            case WM_NCLBUTTONDOWN: 
                {
                    // get the pointer to the main window 
                    CWnd *pWnd =  AfxGetMainWnd(); 
				
                    // if the message is from your window and 
                    // the hit test indicates title bar 
                    if((mhs->hwnd == pWnd->GetSafeHwnd()) 
						&& (mhs->wHitTestCode == HTCAPTION)) 
                    { 
                        // indicate non-client left button down 
                        bNcLButtonDown = TRUE;
                        
                        // there is no problem with this message
                        // so you dont't have to do anything else
                    }
                }
                break;

            case WM_NCLBUTTONUP: 
                // you will get this message if you double-click on the title bar 
                // reset the status
                bNcLButtonDown = FALSE; 
                break; 

            case WM_LBUTTONUP: 
                {
                    // get the pointer to the main window 
                    CWnd *pWnd =  AfxGetMainWnd(); 

                    // if the message is from your window and 
                    // non-client left button is down 
                    if((mhs->hwnd == pWnd->GetSafeHwnd()) 
						&& (bNcLButtonDown == TRUE))
                    {
                        // then post WM_NCLBUTTONUP message directly into your window message pump 
                        // Note: I'm hardcoding HTCAPTION because the left button was down, 
                        // and while it is down, the mouse does not move in respect to the window 
                        // but it does in respect to the screen, so the mouse should still be 
                        // over the caption bar of your window when you release the button. 
                        pWnd->PostMessage(WM_NCLBUTTONUP, HTCAPTION, MAKELONG(mhs->pt.x, mhs->pt.y)); 
						
                        // reset non-client left button down 
                        bNcLButtonDown = FALSE;
                    }
                } 
                break; 

            default: 
                break; 
        } 
    } 
    // let the	messages through to the next hook 
	return CallNextHookEx(hMHook, nCode, wParam, lParam); 
}
